﻿using System;
using System.IO;
using System.IO.Compression;
using System.Diagnostics;
using System.Xml;
using System.Collections.Generic;
using System.Xml.Linq;
using System.Linq;
using System.Threading.Tasks;
using System.Collections.Concurrent;
using System.Threading;
using System.Threading.Channels;

namespace ksp_osm
{
    class Program
    {

        static IEnumerable<Way> LoadWays(string file) =>
            ParallelOsmReader.LoadElements(file, (e, id) => e == "way")
            .Select(Way.FromXml);

        static Stopwatch sw = new Stopwatch();
        static async Task<int> Main(string[] args)
        {
            if (args.Length != 1) {
                Console.Error.WriteLine("Usage: ./" + System.AppDomain.CurrentDomain.FriendlyName
                + " <file.xml.gz>");
                return 1;
            }

            var file = args[0];

            var ulice =
                LoadWays(file)
                .Where(f => f.Tags.ContainsKey("name") && f.Tags.ContainsKey("highway"))
                .Select(f => f.Tags["name"])
                .Distinct();

            // foreach (var u in ulice.OrderBy(a => a))
            //     Console.WriteLine(u);

            var result = ulice.Count();

            Console.WriteLine("Počet ulic: " + result);
            return 0;
        }
    }
}
