using System;
using System.Collections.Generic;
using System.Linq;
using System.Xml.Linq;

namespace ksp_osm
{
    public struct Way
    {
        public Way(long id,
                   Dictionary<string, string> tags,
                   long[] nodeRefs)
        {
            Id = id;
            Tags = tags;
            NodeRefs = nodeRefs;
        }

        public long Id { get; }
        public Dictionary<string, string> Tags { get; }
        public long[] NodeRefs { get; }

        public static Way FromXml(XElement xml)
        {
            return new Way(
                id: (long)xml.Attribute("id"),
                tags: Node.ReadTags(xml.Elements("tag")),
                nodeRefs: xml.Elements("nd").Select(e => (long)e.Attribute("ref")).ToArray()
            );
        }

        public override string ToString()
        {
            return $"Way {Id}";
        }
    }
}
